"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.assertAccountDataNode = exports.isAccountDataNode = exports.accountDataNode = void 0;
const shared_1 = require("../shared");
function accountDataNode(input) {
    if (!input.name) {
        throw new shared_1.InvalidKinobiTreeError('AccountDataNode must have a name.');
    }
    return {
        kind: 'accountDataNode',
        name: (0, shared_1.mainCase)(input.name),
        struct: input.struct,
        link: input.link,
    };
}
exports.accountDataNode = accountDataNode;
function isAccountDataNode(node) {
    return !!node && node.kind === 'accountDataNode';
}
exports.isAccountDataNode = isAccountDataNode;
function assertAccountDataNode(node) {
    var _a;
    if (!isAccountDataNode(node)) {
        throw new Error(`Expected accountDataNode, got ${(_a = node === null || node === void 0 ? void 0 : node.kind) !== null && _a !== void 0 ? _a : 'null'}.`);
    }
}
exports.assertAccountDataNode = assertAccountDataNode;
//# sourceMappingURL=AccountDataNode.js.map