"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.assertBoolTypeNode = exports.isBoolTypeNode = exports.displayBoolTypeNode = exports.boolTypeNode = void 0;
const NumberTypeNode_1 = require("./NumberTypeNode");
function boolTypeNode(size) {
    return {
        kind: 'boolTypeNode',
        size: size !== null && size !== void 0 ? size : (0, NumberTypeNode_1.numberTypeNode)('u8'),
    };
}
exports.boolTypeNode = boolTypeNode;
function displayBoolTypeNode(node) {
    return `bool(${(0, NumberTypeNode_1.displayNumberTypeNode)(node.size)})`;
}
exports.displayBoolTypeNode = displayBoolTypeNode;
function isBoolTypeNode(node) {
    return !!node && node.kind === 'boolTypeNode';
}
exports.isBoolTypeNode = isBoolTypeNode;
function assertBoolTypeNode(node) {
    var _a;
    if (!isBoolTypeNode(node)) {
        throw new Error(`Expected boolTypeNode, got ${(_a = node === null || node === void 0 ? void 0 : node.kind) !== null && _a !== void 0 ? _a : 'null'}.`);
    }
}
exports.assertBoolTypeNode = assertBoolTypeNode;
//# sourceMappingURL=BoolTypeNode.js.map