"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.assertDefinedTypeNode = exports.isDefinedTypeNode = exports.definedTypeNodeFromIdl = exports.definedTypeNode = void 0;
const shared_1 = require("../shared");
const TypeNode_1 = require("./TypeNode");
function definedTypeNode(input) {
    var _a, _b, _c;
    if (!input.name) {
        throw new shared_1.InvalidKinobiTreeError('DefinedTypeNode must have a name.');
    }
    return {
        kind: 'definedTypeNode',
        name: (0, shared_1.mainCase)(input.name),
        data: input.data,
        idlName: (_a = input.idlName) !== null && _a !== void 0 ? _a : input.name,
        docs: (_b = input.docs) !== null && _b !== void 0 ? _b : [],
        internal: (_c = input.internal) !== null && _c !== void 0 ? _c : false,
    };
}
exports.definedTypeNode = definedTypeNode;
function definedTypeNodeFromIdl(idl) {
    var _a, _b;
    const name = (_a = idl.name) !== null && _a !== void 0 ? _a : '';
    const idlType = (_b = idl.type) !== null && _b !== void 0 ? _b : { kind: 'struct', fields: [] };
    const data = (0, TypeNode_1.createTypeNodeFromIdl)(idlType);
    return definedTypeNode({ name, data, idlName: name, docs: idl.docs });
}
exports.definedTypeNodeFromIdl = definedTypeNodeFromIdl;
function isDefinedTypeNode(node) {
    return !!node && node.kind === 'definedTypeNode';
}
exports.isDefinedTypeNode = isDefinedTypeNode;
function assertDefinedTypeNode(node) {
    var _a;
    if (!isDefinedTypeNode(node)) {
        throw new Error(`Expected definedTypeNode, got ${(_a = node === null || node === void 0 ? void 0 : node.kind) !== null && _a !== void 0 ? _a : 'null'}.`);
    }
}
exports.assertDefinedTypeNode = assertDefinedTypeNode;
//# sourceMappingURL=DefinedTypeNode.js.map