"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.assertEnumTupleVariantTypeNode = exports.isEnumTupleVariantTypeNode = exports.enumTupleVariantTypeNodeFromIdl = exports.enumTupleVariantTypeNode = void 0;
const shared_1 = require("../shared");
const TupleTypeNode_1 = require("./TupleTypeNode");
function enumTupleVariantTypeNode(name, tuple) {
    if (!name) {
        throw new shared_1.InvalidKinobiTreeError('EnumTupleVariantTypeNode must have a name.');
    }
    return {
        kind: 'enumTupleVariantTypeNode',
        name: (0, shared_1.mainCase)(name),
        tuple,
    };
}
exports.enumTupleVariantTypeNode = enumTupleVariantTypeNode;
function enumTupleVariantTypeNodeFromIdl(idl) {
    var _a;
    const name = (_a = idl.name) !== null && _a !== void 0 ? _a : '';
    return enumTupleVariantTypeNode(name, (0, TupleTypeNode_1.tupleTypeNodeFromIdl)({ tuple: idl.fields }));
}
exports.enumTupleVariantTypeNodeFromIdl = enumTupleVariantTypeNodeFromIdl;
function isEnumTupleVariantTypeNode(node) {
    return !!node && node.kind === 'enumTupleVariantTypeNode';
}
exports.isEnumTupleVariantTypeNode = isEnumTupleVariantTypeNode;
function assertEnumTupleVariantTypeNode(node) {
    var _a;
    if (!isEnumTupleVariantTypeNode(node)) {
        throw new Error(`Expected enumTupleVariantTypeNode, got ${(_a = node === null || node === void 0 ? void 0 : node.kind) !== null && _a !== void 0 ? _a : 'null'}.`);
    }
}
exports.assertEnumTupleVariantTypeNode = assertEnumTupleVariantTypeNode;
//# sourceMappingURL=EnumTupleVariantTypeNode.js.map