"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.assertInstructionDataArgsNode = exports.isInstructionDataArgsNode = exports.instructionDataArgsNode = void 0;
const shared_1 = require("../shared");
function instructionDataArgsNode(input) {
    if (!input.name) {
        throw new shared_1.InvalidKinobiTreeError('InstructionDataArgsNode must have a name.');
    }
    return {
        kind: 'instructionDataArgsNode',
        name: (0, shared_1.mainCase)(input.name),
        struct: input.struct,
        link: input.link,
    };
}
exports.instructionDataArgsNode = instructionDataArgsNode;
function isInstructionDataArgsNode(node) {
    return !!node && node.kind === 'instructionDataArgsNode';
}
exports.isInstructionDataArgsNode = isInstructionDataArgsNode;
function assertInstructionDataArgsNode(node) {
    var _a;
    if (!isInstructionDataArgsNode(node)) {
        throw new Error(`Expected instructionDataArgsNode, got ${(_a = node === null || node === void 0 ? void 0 : node.kind) !== null && _a !== void 0 ? _a : 'null'}.`);
    }
}
exports.assertInstructionDataArgsNode = assertInstructionDataArgsNode;
//# sourceMappingURL=InstructionDataArgsNode.js.map