"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.displaySizeStrategy = exports.remainderSize = exports.prefixedSize = exports.fixedSize = void 0;
const NumberTypeNode_1 = require("../nodes/NumberTypeNode");
const fixedSize = (value) => ({
    kind: 'fixed',
    value,
});
exports.fixedSize = fixedSize;
const prefixedSize = (prefix) => ({
    kind: 'prefixed',
    prefix: prefix !== null && prefix !== void 0 ? prefix : (0, NumberTypeNode_1.numberTypeNode)('u32'),
});
exports.prefixedSize = prefixedSize;
const remainderSize = () => ({ kind: 'remainder' });
exports.remainderSize = remainderSize;
const displaySizeStrategy = (size) => {
    if (size.kind === 'fixed')
        return `${size.value}`;
    if (size.kind === 'prefixed')
        return `${(0, NumberTypeNode_1.displayNumberTypeNode)(size.prefix)}`;
    return 'remainder';
};
exports.displaySizeStrategy = displaySizeStrategy;
//# sourceMappingURL=SizeStrategy.js.map