"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.renameEnumNode = exports.renameStructNode = void 0;
const nodes = __importStar(require("../../nodes"));
function renameStructNode(node, map) {
    return nodes.structTypeNode(node.fields.map((field) => map[field.name]
        ? nodes.structFieldTypeNode({ ...field, name: map[field.name] })
        : field));
}
exports.renameStructNode = renameStructNode;
function renameEnumNode(node, map) {
    return nodes.enumTypeNode(node.variants.map((variant) => map[variant.name]
        ? renameEnumVariant(variant, map[variant.name])
        : variant), { ...node });
}
exports.renameEnumNode = renameEnumNode;
function renameEnumVariant(variant, newName) {
    if (nodes.isEnumStructVariantTypeNode(variant)) {
        return nodes.enumStructVariantTypeNode(newName, variant.struct);
    }
    if (nodes.isEnumTupleVariantTypeNode(variant)) {
        return nodes.enumTupleVariantTypeNode(newName, variant.tuple);
    }
    return nodes.enumEmptyVariantTypeNode(newName);
}
//# sourceMappingURL=_renameHelpers.js.map