import type { IdlAccount } from '../idl';
import { AccountDiscriminator, AccountSeed, PartialExcept } from '../shared';
import { AccountDataNode } from './AccountDataNode';
import type { Node } from './Node';
export type AccountNode = {
    readonly __accountNode: unique symbol;
    readonly kind: 'accountNode';
    readonly name: string;
    readonly data: AccountDataNode;
    readonly idlName: string;
    readonly docs: string[];
    readonly internal: boolean;
    readonly size?: number;
    readonly seeds: AccountSeed[];
    readonly discriminator?: AccountDiscriminator;
};
export type AccountNodeInput = Omit<PartialExcept<AccountNode, 'name' | 'data'>, '__accountNode' | 'kind'>;
export declare function accountNode(input: AccountNodeInput): AccountNode;
export declare function accountNodeFromIdl(idl: Partial<IdlAccount>): AccountNode;
export declare function isAccountNode(node: Node | null): node is AccountNode;
export declare function assertAccountNode(node: Node | null): asserts node is AccountNode;
