import type { IdlTypeArray, IdlTypeVec } from '../idl';
import { SizeStrategy } from '../shared/SizeStrategy';
import type { Node } from './Node';
import { TypeNode } from './TypeNode';
export type ArrayTypeNode = {
    readonly __arrayTypeNode: unique symbol;
    readonly kind: 'arrayTypeNode';
    readonly child: TypeNode;
    readonly size: SizeStrategy;
};
export declare function arrayTypeNode(child: TypeNode, options?: {
    readonly size?: ArrayTypeNode['size'];
}): ArrayTypeNode;
export declare function arrayTypeNodeFromIdl(idl: IdlTypeArray | IdlTypeVec): ArrayTypeNode;
export declare function isArrayTypeNode(node: Node | null): node is ArrayTypeNode;
export declare function assertArrayTypeNode(node: Node | null): asserts node is ArrayTypeNode;
