import type { IdlError } from '../idl';
import { PartialExcept } from '../shared';
import type { Node } from './Node';
export type ErrorNode = {
    readonly __errorNode: unique symbol;
    readonly kind: 'errorNode';
    readonly name: string;
    readonly idlName: string;
    readonly code: number;
    readonly message: string;
    readonly docs: string[];
};
export type ErrorNodeInput = Omit<PartialExcept<ErrorNode, 'name' | 'code' | 'message'>, '__errorNode' | 'kind'>;
export declare function errorNode(input: ErrorNodeInput): ErrorNode;
export declare function errorNodeFromIdl(idl: Partial<IdlError>): ErrorNode;
export declare function isErrorNode(node: Node | null): node is ErrorNode;
export declare function assertErrorNode(node: Node | null): asserts node is ErrorNode;
