import type { Node } from './Node';
export type NumberFormat = 'u8' | 'u16' | 'u32' | 'u64' | 'u128' | 'i8' | 'i16' | 'i32' | 'i64' | 'i128' | 'f32' | 'f64';
export type NumberTypeNode = {
    readonly __numberTypeNode: unique symbol;
    readonly kind: 'numberTypeNode';
    readonly format: NumberFormat;
    readonly endian: 'le' | 'be';
};
export declare function numberTypeNode(format: NumberFormat, endian?: 'le' | 'be'): NumberTypeNode;
export declare function isSignedInteger(node: NumberTypeNode): boolean;
export declare function isUnsignedInteger(node: NumberTypeNode): boolean;
export declare function isInteger(node: NumberTypeNode): boolean;
export declare function isDecimal(node: NumberTypeNode): boolean;
export declare function displayNumberTypeNode(node: NumberTypeNode): string;
export declare function isNumberTypeNode(node: Node | null): node is NumberTypeNode;
export declare function assertNumberTypeNode(node: Node | null): asserts node is NumberTypeNode;
