import { SizeStrategy } from '../shared/SizeStrategy';
import type { Node } from './Node';
export type StringEncoding = 'utf8' | 'base16' | 'base58' | 'base64';
export type StringTypeNode = {
    readonly __stringTypeNode: unique symbol;
    readonly kind: 'stringTypeNode';
    readonly encoding: StringEncoding;
    readonly size: SizeStrategy;
};
export declare function stringTypeNode(options?: {
    readonly encoding?: StringEncoding;
    readonly size?: SizeStrategy;
}): StringTypeNode;
export declare function displayStringTypeNode(node: StringTypeNode): string;
export declare function isStringTypeNode(node: Node | null): node is StringTypeNode;
export declare function assertStringTypeNode(node: Node | null): asserts node is StringTypeNode;
