import { IdlType } from '../idl';
import { ArrayTypeNode } from './ArrayTypeNode';
import { BoolTypeNode } from './BoolTypeNode';
import { BytesTypeNode } from './BytesTypeNode';
import { EnumTypeNode } from './EnumTypeNode';
import { LinkTypeNode } from './LinkTypeNode';
import { MapTypeNode } from './MapTypeNode';
import type { Node } from './Node';
import { NumberTypeNode } from './NumberTypeNode';
import { NumberWrapperTypeNode } from './NumberWrapperTypeNode';
import { OptionTypeNode } from './OptionTypeNode';
import { PublicKeyTypeNode } from './PublicKeyTypeNode';
import { SetTypeNode } from './SetTypeNode';
import { StringTypeNode } from './StringTypeNode';
import { StructTypeNode } from './StructTypeNode';
import { TupleTypeNode } from './TupleTypeNode';
export type TypeNode = ArrayTypeNode | BoolTypeNode | BytesTypeNode | LinkTypeNode | EnumTypeNode | MapTypeNode | NumberTypeNode | NumberWrapperTypeNode | OptionTypeNode | PublicKeyTypeNode | SetTypeNode | StringTypeNode | StructTypeNode | TupleTypeNode;
export declare const createTypeNodeFromIdl: (idlType: IdlType) => TypeNode;
export declare function isTypeNode(node: Node | null): node is TypeNode;
export declare function assertTypeNode(node: Node | null): asserts node is TypeNode;
export declare function isStructOrLinkTypeNode(node: Node | null): node is StructTypeNode | LinkTypeNode;
export declare function assertStructOrLinkTypeNode(node: Node | null): asserts node is StructTypeNode | LinkTypeNode;
