import { Visitor } from './Visitor';
import * as nodes from '../nodes';
export declare class BaseNodeOrNullVisitor implements Visitor<nodes.Node | null> {
    visitRoot(root: nodes.RootNode): nodes.Node | null;
    visitProgram(program: nodes.ProgramNode): nodes.Node | null;
    visitAccount(account: nodes.AccountNode): nodes.Node | null;
    visitAccountData(accountData: nodes.AccountDataNode): nodes.Node | null;
    visitInstruction(instruction: nodes.InstructionNode): nodes.Node | null;
    visitInstructionAccount(instructionAccount: nodes.InstructionAccountNode): nodes.Node | null;
    visitInstructionDataArgs(instructionDataArgs: nodes.InstructionDataArgsNode): nodes.Node | null;
    visitInstructionExtraArgs(instructionExtraArgs: nodes.InstructionExtraArgsNode): nodes.Node | null;
    visitDefinedType(definedType: nodes.DefinedTypeNode): nodes.Node | null;
    visitError(error: nodes.ErrorNode): nodes.Node | null;
    visitArrayType(arrayType: nodes.ArrayTypeNode): nodes.Node | null;
    visitLinkType(linkType: nodes.LinkTypeNode): nodes.Node | null;
    visitEnumType(enumType: nodes.EnumTypeNode): nodes.Node | null;
    visitEnumEmptyVariantType(enumEmptyVariantType: nodes.EnumEmptyVariantTypeNode): nodes.Node | null;
    visitEnumStructVariantType(enumStructVariantType: nodes.EnumStructVariantTypeNode): nodes.Node | null;
    visitEnumTupleVariantType(enumTupleVariantType: nodes.EnumTupleVariantTypeNode): nodes.Node | null;
    visitMapType(mapType: nodes.MapTypeNode): nodes.Node | null;
    visitOptionType(optionType: nodes.OptionTypeNode): nodes.Node | null;
    visitSetType(setType: nodes.SetTypeNode): nodes.Node | null;
    visitStructType(structType: nodes.StructTypeNode): nodes.Node | null;
    visitStructFieldType(structFieldType: nodes.StructFieldTypeNode): nodes.Node | null;
    visitTupleType(tupleType: nodes.TupleTypeNode): nodes.Node | null;
    visitBoolType(boolType: nodes.BoolTypeNode): nodes.Node | null;
    visitBytesType(bytesType: nodes.BytesTypeNode): nodes.Node | null;
    visitNumberType(numberType: nodes.NumberTypeNode): nodes.Node | null;
    visitNumberWrapperType(numberWrapperType: nodes.NumberWrapperTypeNode): nodes.Node | null;
    visitPublicKeyType(publicKeyType: nodes.PublicKeyTypeNode): nodes.Node | null;
    visitStringType(stringType: nodes.StringTypeNode): nodes.Node | null;
}
