import * as nodes from '../nodes';
import { Visitor } from './Visitor';
export declare abstract class BaseVoidVisitor implements Visitor<void> {
    visitRoot(root: nodes.RootNode): void;
    visitProgram(program: nodes.ProgramNode): void;
    visitAccount(account: nodes.AccountNode): void;
    visitAccountData(accountData: nodes.AccountDataNode): void;
    visitInstruction(instruction: nodes.InstructionNode): void;
    visitInstructionAccount(instructionAccount: nodes.InstructionAccountNode): void;
    visitInstructionDataArgs(instructionDataArgs: nodes.InstructionDataArgsNode): void;
    visitInstructionExtraArgs(instructionExtraArgs: nodes.InstructionExtraArgsNode): void;
    visitDefinedType(definedType: nodes.DefinedTypeNode): void;
    visitError(error: nodes.ErrorNode): void;
    visitArrayType(arrayType: nodes.ArrayTypeNode): void;
    visitLinkType(linkType: nodes.LinkTypeNode): void;
    visitEnumType(enumType: nodes.EnumTypeNode): void;
    visitEnumEmptyVariantType(enumEmptyVariantType: nodes.EnumEmptyVariantTypeNode): void;
    visitEnumStructVariantType(enumStructVariantType: nodes.EnumStructVariantTypeNode): void;
    visitEnumTupleVariantType(enumTupleVariantType: nodes.EnumTupleVariantTypeNode): void;
    visitMapType(mapType: nodes.MapTypeNode): void;
    visitOptionType(optionType: nodes.OptionTypeNode): void;
    visitSetType(setType: nodes.SetTypeNode): void;
    visitStructType(structType: nodes.StructTypeNode): void;
    visitStructFieldType(structFieldType: nodes.StructFieldTypeNode): void;
    visitTupleType(tupleType: nodes.TupleTypeNode): void;
    visitBoolType(boolType: nodes.BoolTypeNode): void;
    visitBytesType(bytesType: nodes.BytesTypeNode): void;
    visitNumberType(numberType: nodes.NumberTypeNode): void;
    visitNumberWrapperType(numberWrapperType: nodes.NumberWrapperTypeNode): void;
    visitPublicKeyType(publicKeyType: nodes.PublicKeyTypeNode): void;
    visitStringType(stringType: nodes.StringTypeNode): void;
}
