import * as nodes from '../../nodes';
import { BaseThrowVisitor } from '../BaseThrowVisitor';
export declare class GetByteSizeVisitor extends BaseThrowVisitor<number | null> {
    private availableDefinedTypes;
    private visitedDefinedTypes;
    private definedTypeStack;
    registerDefinedTypes(definedTypes: nodes.DefinedTypeNode[]): void;
    visitAccount(account: nodes.AccountNode): number | null;
    visitAccountData(accountData: nodes.AccountDataNode): number | null;
    visitInstruction(instruction: nodes.InstructionNode): number | null;
    visitInstructionDataArgs(instructionDataArgs: nodes.InstructionDataArgsNode): number | null;
    visitInstructionExtraArgs(instructionExtraArgs: nodes.InstructionExtraArgsNode): number | null;
    visitDefinedType(definedType: nodes.DefinedTypeNode): number | null;
    visitArrayType(arrayType: nodes.ArrayTypeNode): number | null;
    visitLinkType(linkType: nodes.LinkTypeNode): number | null;
    visitEnumType(enumType: nodes.EnumTypeNode): number | null;
    visitEnumEmptyVariantType(): number | null;
    visitEnumStructVariantType(enumStructVariantType: nodes.EnumStructVariantTypeNode): number | null;
    visitEnumTupleVariantType(enumTupleVariantType: nodes.EnumTupleVariantTypeNode): number | null;
    visitMapType(): number | null;
    visitOptionType(optionType: nodes.OptionTypeNode): number | null;
    visitSetType(): number | null;
    visitStructType(structType: nodes.StructTypeNode): number | null;
    visitStructFieldType(structFieldType: nodes.StructFieldTypeNode): number | null;
    visitTupleType(tupleType: nodes.TupleTypeNode): number | null;
    visitBoolType(boolType: nodes.BoolTypeNode): number | null;
    visitBytesType(bytesType: nodes.BytesTypeNode): number | null;
    visitNumberType(numberType: nodes.NumberTypeNode): number | null;
    visitNumberWrapperType(numberWrapperType: nodes.NumberWrapperTypeNode): number | null;
    visitPublicKeyType(): number | null;
    visitStringType(stringType: nodes.StringTypeNode): number | null;
    protected sumSizes(sizes: (number | null)[]): number | null;
}
