import * as nodes from '../../nodes';
import { NodeStack } from '../NodeStack';
import { ValidatorBag } from '../ValidatorBag';
import { Visitor } from '../Visitor';
export declare class GetDefaultValidatorBagVisitor implements Visitor<ValidatorBag> {
    protected stack: NodeStack;
    protected program: nodes.ProgramNode | null;
    protected definedTypes: Set<string>;
    visitRoot(root: nodes.RootNode): ValidatorBag;
    visitProgram(program: nodes.ProgramNode): ValidatorBag;
    visitAccount(account: nodes.AccountNode): ValidatorBag;
    visitAccountData(accountData: nodes.AccountDataNode): ValidatorBag;
    visitInstruction(instruction: nodes.InstructionNode): ValidatorBag;
    visitInstructionAccount(instructionAccount: nodes.InstructionAccountNode): ValidatorBag;
    visitInstructionDataArgs(instructionDataArgs: nodes.InstructionDataArgsNode): ValidatorBag;
    visitInstructionExtraArgs(instructionExtraArgs: nodes.InstructionExtraArgsNode): ValidatorBag;
    visitDefinedType(definedType: nodes.DefinedTypeNode): ValidatorBag;
    visitError(error: nodes.ErrorNode): ValidatorBag;
    visitArrayType(arrayType: nodes.ArrayTypeNode): ValidatorBag;
    visitLinkType(linkType: nodes.LinkTypeNode): ValidatorBag;
    visitEnumType(enumType: nodes.EnumTypeNode): ValidatorBag;
    visitEnumEmptyVariantType(enumEmptyVariantType: nodes.EnumEmptyVariantTypeNode): ValidatorBag;
    visitEnumStructVariantType(enumStructVariantType: nodes.EnumStructVariantTypeNode): ValidatorBag;
    visitEnumTupleVariantType(enumTupleVariantType: nodes.EnumTupleVariantTypeNode): ValidatorBag;
    visitMapType(mapType: nodes.MapTypeNode): ValidatorBag;
    visitOptionType(optionType: nodes.OptionTypeNode): ValidatorBag;
    visitSetType(setType: nodes.SetTypeNode): ValidatorBag;
    visitStructType(structType: nodes.StructTypeNode): ValidatorBag;
    visitStructFieldType(structFieldType: nodes.StructFieldTypeNode): ValidatorBag;
    visitTupleType(tupleType: nodes.TupleTypeNode): ValidatorBag;
    visitBoolType(boolType: nodes.BoolTypeNode): ValidatorBag;
    visitBytesType(bytesType: nodes.BytesTypeNode): ValidatorBag;
    visitNumberType(numberType: nodes.NumberTypeNode): ValidatorBag;
    visitNumberWrapperType(numberWrapperType: nodes.NumberWrapperTypeNode): ValidatorBag;
    visitPublicKeyType(publicKeyType: nodes.PublicKeyTypeNode): ValidatorBag;
    visitStringType(stringType: nodes.StringTypeNode): ValidatorBag;
    protected pushNode(node: nodes.Node): void;
    protected popNode(): nodes.Node | undefined;
}
