import * as nodes from '../../nodes';
import { Visitor } from '../Visitor';
export type DefinedTypeHistogram = {
    [key: string]: {
        total: number;
        inAccounts: number;
        inDefinedTypes: number;
        inInstructionArgs: number;
        directlyAsInstructionArgs: number;
    };
};
export declare class GetDefinedTypeHistogramVisitor implements Visitor<DefinedTypeHistogram> {
    private mode;
    private stackLevel;
    visitRoot(root: nodes.RootNode): DefinedTypeHistogram;
    visitProgram(program: nodes.ProgramNode): DefinedTypeHistogram;
    visitAccount(account: nodes.AccountNode): DefinedTypeHistogram;
    visitAccountData(accountData: nodes.AccountDataNode): DefinedTypeHistogram;
    visitInstruction(instruction: nodes.InstructionNode): DefinedTypeHistogram;
    visitInstructionAccount(): DefinedTypeHistogram;
    visitInstructionDataArgs(instructionDataArgs: nodes.InstructionDataArgsNode): DefinedTypeHistogram;
    visitInstructionExtraArgs(instructionExtraArgs: nodes.InstructionExtraArgsNode): DefinedTypeHistogram;
    visitDefinedType(definedType: nodes.DefinedTypeNode): DefinedTypeHistogram;
    visitError(): DefinedTypeHistogram;
    visitArrayType(arrayType: nodes.ArrayTypeNode): DefinedTypeHistogram;
    visitLinkType(linkType: nodes.LinkTypeNode): DefinedTypeHistogram;
    visitEnumType(enumType: nodes.EnumTypeNode): DefinedTypeHistogram;
    visitEnumEmptyVariantType(): DefinedTypeHistogram;
    visitEnumStructVariantType(enumStructVariantType: nodes.EnumStructVariantTypeNode): DefinedTypeHistogram;
    visitEnumTupleVariantType(enumTupleVariantType: nodes.EnumTupleVariantTypeNode): DefinedTypeHistogram;
    visitMapType(mapType: nodes.MapTypeNode): DefinedTypeHistogram;
    visitOptionType(optionType: nodes.OptionTypeNode): DefinedTypeHistogram;
    visitSetType(setType: nodes.SetTypeNode): DefinedTypeHistogram;
    visitStructType(structType: nodes.StructTypeNode): DefinedTypeHistogram;
    visitStructFieldType(structFieldType: nodes.StructFieldTypeNode): DefinedTypeHistogram;
    visitTupleType(tupleType: nodes.TupleTypeNode): DefinedTypeHistogram;
    visitBoolType(): DefinedTypeHistogram;
    visitBytesType(): DefinedTypeHistogram;
    visitNumberType(): DefinedTypeHistogram;
    visitNumberWrapperType(numberWrapperType: nodes.NumberWrapperTypeNode): DefinedTypeHistogram;
    visitPublicKeyType(): DefinedTypeHistogram;
    visitStringType(): DefinedTypeHistogram;
    protected mergeHistograms(histograms: DefinedTypeHistogram[]): DefinedTypeHistogram;
}
